
#include "gamebase/GameBase.hpp"
#include "gamebase/PGNGameBase.hpp"
#include "GameListManager.hpp"

// Foreign events
wxDECLARE_EVENT(OPEN_GAME_EVENT, wxCommandEvent);
wxDECLARE_EVENT(CLOSE_LINKED_TAB, wxCommandEvent);

class BaseGameTab : public TabBase_TabGames {
  std::shared_ptr<GameBase> base;
  std::vector<std::uint32_t> deleted;
  std::unordered_map<long, std::shared_ptr<Game>> edited;
  TabInfos *main_tab;

public:
  std::shared_ptr<GameListManager> glm;

  BaseGameTab(wxFrame *parent, std::shared_ptr<GameBase> base, TabInfos *main_tab);

  void Reset(std::shared_ptr<GameBase> base);
  void OnDelete(wxCommandEvent &event);
  void OnSave(wxCommandEvent &event);
  void OnExport(wxCommandEvent &event);
  void OnOpenGame(wxListEvent &event);
  void OnImport(wxCommandEvent &event);
  void OnApplyFilter(wxCommandEvent &event);
  std::vector<std::shared_ptr<Game>> GetEditedGames();
  std::vector<std::uint32_t> GetDeletedGameIds() {return(deleted);};
  std::shared_ptr<Game> GetGame() { return (std::shared_ptr<Game>(NULL)); }
  std::shared_ptr<GameBase> GetBase() { return (std::shared_ptr<GameBase>(base)); };
};